#include <iostream>
#include <string>
#include <vector>
#include<algorithm>
#include<sstream>
using namespace std;


//Definition for singly-linked list.
struct ListNode 
{
    int val;
    ListNode *next;
    ListNode(int x) : val(x), next(NULL) {}
};

static int x = []() {std::ios::sync_with_stdio(false); cin.tie(0); return 0; }();
class Solution 
{
public:
    ListNode *detectCycle(ListNode *head) 
    {
        if (head == nullptr) return nullptr;
        auto fast = head;
        auto slow = head;
        auto entry = head;
        while (fast->next and fast->next->next)
        {
            slow = slow->next;
            fast = fast->next->next;
            if (slow == fast)
            {
                while (slow != entry)
                {
                    slow = slow->next;
                    entry = entry->next;
                }
                return entry;
            }
        }
        return nullptr;
    }
};

void printList(ListNode *pNode) {
    cout << "LinkList traversal:" << endl;
    while(pNode != nullptr) {
        cout << pNode->val << " ";
	pNode = pNode->next;
    }
    cout << endl;
}

void printList(ListNode *pNode, const int size) {
    cout << "LinkList traversal:" << endl;
    int cnt = size;
    while(pNode != nullptr && cnt--) {
        cout << pNode->val << " ";
	pNode = pNode->next;
    }
    cout << endl;
}

void trimLeftTrailingSpaces(string &input) {
    input.erase(input.begin(), find_if(input.begin(), input.end(), [](int ch) {
        return !isspace(ch);
    }));
}

void trimRightTrailingSpaces(string &input) {
    input.erase(find_if(input.rbegin(), input.rend(), [](int ch) {
        return !isspace(ch);
    }).base(), input.end());
}

string StrProcess(string str) {
    int pos1 = str.find("[");
    int pos2 = str.find("]");
    string newStr = str.substr(pos1+1, pos2-pos1-1);  
    //newStr.erase(std::remove(newStr.begin(), newStr.end(), ','), newStr.end());

    return newStr;
}

vector<string> stringToVector(string input) {
    vector<string> inputVector;

    trimLeftTrailingSpaces(input);
    trimRightTrailingSpaces(input);
    input = input.substr(0, input.length());//去掉[1,2,3,null,5,null,4]中的前面的[和最后的],变为:1,2,3,null,5,null,4;

    string item;
    stringstream ss;
    ss.str(input);

    getline(ss, item, ',');                         
    inputVector.push_back(item);

    while (true) {                               
        if (!getline(ss, item, ',')) {    
            break;
        }
        trimLeftTrailingSpaces(item);
        trimRightTrailingSpaces(item);
	//cout << item << endl;
        inputVector.push_back(item);
    }

    return inputVector;
}

vector<int> stringToIntegerVector(string input) {
    vector<int> output;
    trimLeftTrailingSpaces(input);
    trimRightTrailingSpaces(input);
    input = input.substr(0, input.length());
    stringstream ss;
    ss.str(input);
    string item;
    char delim = ',';
    while (getline(ss, item, delim)) {
        output.push_back(stoi(item));
    }
    for(auto ch : output) {
        cout << ch << " ";
    }
    cout << endl;
    return output;
}

string integerVectorToString(vector<int> list, int length = -1) {
    if (length == -1) {
        length = list.size();
    }

    if (length == 0) {
        return "[]";
    }

    string result;
    for(int index = 0; index < length; index++) {
        int number = list[index];
        result += to_string(number) + ", ";
    }
    return "[" + result.substr(0, result.length() - 2) + "]";
}

ListNode* stringToListNode(string input) {
    // Generate list from the input
    vector<int> list = stringToIntegerVector(input);

    // Now convert that list into linked list
    ListNode* dummyRoot = new ListNode(0);
    ListNode* ptr = dummyRoot;
    for(int item : list) {
        ptr->next = new ListNode(item);
        ptr = ptr->next;
    }
    ptr = dummyRoot->next;
    delete dummyRoot;
    return ptr;
}

ListNode* stringToCycleListNode(string input) {
    // Generate list from the input
    vector<int> list = stringToIntegerVector(input);

    // Now convert that list into linked list
    ListNode* dummyRoot = new ListNode(0);
    ListNode* ptr = dummyRoot;
    ListNode* entry = dummyRoot;

    for(int item : list) {
        ptr->next = new ListNode(item);
        ptr = ptr->next;
	if(item == 2) {
	    entry = ptr;
	}
    }
    ptr->next = entry;
    ptr = dummyRoot->next;
    delete dummyRoot;
    return ptr;
}

bool hasCycle(ListNode *head) 
{
    if (head == nullptr) return false;
    auto fast = head;
    auto slow = head;
    while (fast->next != nullptr and fast->next->next != nullptr)
    {
        slow = slow->next;
        fast = fast->next->next;
        if (slow == fast) return true;
    }
    return false;
}

int main() {
    string line;
    string inputline;
    while (getline(cin, line)) {
	inputline = StrProcess(line);
	cout << inputline << endl;

        //ListNode* head = stringToListNode(inputline);
        ListNode* head = stringToCycleListNode(inputline);
	//printList(head);
	printList(head,15);

	if(hasCycle(head)) {
	    cout << "This is a cycle list" << endl;
	} else {
	    cout << "This is not a cycle list" << endl;
	}

        ListNode* ret = Solution().detectCycle(head);
	cout << "Entry node val:" << ret->val << endl;
	return 0;

	/*
        string out = listNodeToString(ret);
        cout << out << endl;
	*/
    }
    return 0;
}
